= nng_aio_set_iov(3)
//
// Copyright 2021 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_aio_set_iov - set scatter/gather vector

== SYNOPSIS

[source,c]
----
#include <nng/nng.h>

int nng_aio_set_iov(nng_aio *aio, unsigned int niov, nng_iov *iov);
----

== DESCRIPTION

The `nng_aio_set_iov()` function sets a ((scatter/gather)) vector _iov_ on the handle _aio_.

The _iov_ is a pointer to an array of _niov_ xref:nng_iov.5.adoc[`nng_iov`]
structures, which have the following definition:

[source,c]
----
    typedef struct nng_iov {
        void * iov_buf;
        size_t iov_len;
    };
----

The _iov_ is copied into storage in the _aio_ itself, so that callers may use stack allocated `nng_iov` structures.
The values pointed to by the `iov_buf` members are *not* copied by this function though.

A maximum of four (4) `nng_iov` members may be supplied.

NOTE: Earlier versions of the library could accept longer scatter-gather lists.
However, no known consumers have ever needed a scatter-gather list longer than 4 vectors.
As a result, the implementation limit was reduced, and heap allocations which could fail were removed.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_EINVAL`:: Value of specified _niov_ is too large.

== SEE ALSO

[.text-left]
xref:nng_aio_alloc.3.adoc[nng_aio_alloc(3)],
xref:nng_aio_cancel.3.adoc[nng_aio_cancel(3)],
xref:nng_aio_count.3.adoc[nng_aio_count(3)],
xref:nng_aio_result.3.adoc[nng_aio_result(3)],
xref:nng_aio.5.adoc[nng_aio(5)],
xref:nng_iov.5.adoc[nng_iov(5)],
xref:nng.7.adoc[nng(7)]
